#pragma once

#include "StringUtil.h"

class CMemServer
{
public:
	CMemServer(LPCWSTR serVerName );
	~CMemServer(void);

	typedef int (CALLBACK *CALLBACK_PROC)(void* pParam, void *buf );
	BOOL Start(CALLBACK_PROC pfnCmdProc, void* pParam, int iThreadPriority = THREAD_PRIORITY_NORMAL);
	void Stop();

	HANDLE DuplicateFileMappingHandle( DWORD processID );

protected:
	CALLBACK_PROC m_pCmdProc;
	void* m_pParam;
	std::wstring m_serverName;

	int m_iThreadPriority;

	HANDLE m_hThread;
	HANDLE m_hStopEvent;
	HANDLE m_hEventConnect; //ڑҋ@pCxg
	HANDLE m_hEventCall;
	HANDLE m_hEventReturn;
	HANDLE m_hMapping;
	BYTE *m_buf;
	DWORD Command();

protected:
	static UINT WINAPI ServerThread(LPVOID pParam);
	UINT ServerThread();
};