#include "stdafx.h"
#include "PT1CreateCtrlCmdUtil.h"

BOOL CreateDefStream(DWORD dwValue, CMD_STREAM* pCmd)
{
	if( pCmd == NULL ){
		return FALSE;
	}
	pCmd->SetSize( sizeof(DWORD) );

	DWORD *p = (DWORD*)pCmd->bData;
	*p = dwValue;

	return TRUE;
}

BOOL CopyDefData(DWORD* pdwValue, BYTE* pBuff)
{
	if( pdwValue == NULL || pBuff == NULL ){
		return FALSE;
	}
	*pdwValue = *(DWORD*)pBuff;

	return TRUE;
}

BOOL CreateDefStream2(DWORD dwValue, DWORD dwValue2, CMD_STREAM* pCmd)
{
	if( pCmd == NULL ){
		return FALSE;
	}
	pCmd->SetSize( sizeof(DWORD)*2 );

	DWORD *p = (DWORD*)pCmd->bData;
	*p++ = dwValue;
	*p++ = dwValue2;

	return TRUE;
}

BOOL CopyDefData2(DWORD* pdwValue, DWORD* pdwValue2, BYTE* pBuff)
{
	if( pdwValue == NULL || pBuff == NULL ){
		return FALSE;
	}
	DWORD *p = (DWORD*)pBuff;
	*pdwValue = *p++;
	*pdwValue2 = *p++;

	return TRUE;
}

BOOL CreateDefStream3(DWORD dwValue, DWORD dwValue2, DWORD dwValue3, CMD_STREAM* pCmd)
{
	if( pCmd == NULL ){
		return FALSE;
	}
	pCmd->SetSize( sizeof(DWORD)*3 );

	DWORD *p = (DWORD *)pCmd->bData;
	*p++ = dwValue;
	*p++ = dwValue2;
	*p++ = dwValue3;

	return TRUE;
}

BOOL CopyDefData3(DWORD* pdwValue, DWORD* pdwValue2, DWORD* pdwValue3, BYTE* pBuff)
{
	if( pdwValue == NULL || pBuff == NULL ){
		return FALSE;
	}
	DWORD *p = (DWORD*)pBuff;
	*pdwValue = *p++;
	*pdwValue2 = *p++;
	*pdwValue3 = *p++;

	return TRUE;
}