#ifndef __PT1_SEND_CTRL_CMD_UTIL_H__
#define __PT1_SEND_CTRL_CMD_UTIL_H__

#include "PT1OutsideCtrlCmdDef.h"
#include "PT1CreateCtrlCmdUtil.h"
#include "StringUtil.h"

#define CONNECT_TIMEOUT 30*1000

class PipeClient {
private:
	HANDLE m_hEventConnect;
	DWORD WaitConnect();

	DWORD Send(HANDLE hPipe, CMD_STREAM &stream);
	DWORD Recv(HANDLE hPipe, CMD_STREAM &stream);
	HANDLE ConnectPipe(LPCWSTR lpwszPipeName);

	DWORD SendDefCmd(LPCWSTR lpwszPipeName, CMD_STREAM* pstSend, CMD_STREAM* pstRes);
	HANDLE SendEnumCmdFirst(LPCWSTR lpwszPipeName, CMD_STREAM* pstSend, CMD_STREAM* pstRes);
	DWORD SendEnumCmdNext(HANDLE hPipe, CMD_STREAM* pstSend, CMD_STREAM* pstRes);
public:
	PipeClient();
	~PipeClient();
	DWORD SendCloseExe();
	DWORD SendOpenTuner(BOOL bSate, int* piID, DWORD *pUnique, HANDLE *phFileMapping);
	DWORD SendOpenTuner2(BOOL bSate, int iTunerID, int* piID, DWORD *pUnique, HANDLE *phFileMapping);
	DWORD SendCloseTuner(int iID);
	DWORD SendSetCh(int iID, DWORD dwCh, DWORD dwTSID);
	DWORD SendGetSignal(int iID, DWORD* pdwCn100);
};

class CMemClient {
public:
	CMemClient() {}
	DWORD Open(int iID, DWORD unique, HANDLE hFileMapping );
	DWORD GetTSBlock();
	BYTE *GetBufferPointer();
	void Close();
private:
	HANDLE m_hEventCall;
	HANDLE m_hEventReturn;
	HANDLE m_hMapping;
	BYTE *m_buf;
};

#endif
