#ifndef __PT1_OUTSIDE_CTRL_CMD_DEF_H__
#define __PT1_OUTSIDE_CTRL_CMD_DEF_H__

#include "Util.h"

#define SEND_BUFF_SIZE 1024*64
#define RES_BUFF_SIZE 1024*64

#define CMD_PT1_DATA _T("PT1Data")

//dN}p~[ebNX
#define PT1_CTRL_MUTEX L"PT1_CTRL_EXE_MUTEX"
#define PT1_CTRL_MUTEX_EXITING L"PT1_CTRL_EXE_MUTEX_EXITING"

//pCv
#define CMD_PT1_CTRL_PIPE _T("\\\\.\\pipe\\PT1CtrlPipe")
#define CMD_PT1_DATA_PIPE _T("\\\\.\\pipe\\PT1DataPipe_")

//ڑҋ@pCxg
#define CMD_PT1_CTRL_EVENT_WAIT_CONNECT _T("Global\\PT1CtrlConnect")
#define CMD_PT1_DATA_EVENT_WAIT_CONNECT _T("Global\\PT1DataConnect_")

//W[R}hsCxg
#define CMD_CTRL_EVENT_WAIT _T("CtrlCmdEvent")

//R}h
#define CMD_CLOSE_EXE 1
#define CMD_OPEN_TUNER 2
#define CMD_CLOSE_TUNER 3
#define CMD_SET_CH 4
#define CMD_GET_SIGNAL 5
#define CMD_OPEN_TUNER2 6
#define CMD_SEND_DATA 10

//G[R[h
#define CMD_SUCCESS			0 //
#define CMD_ERR				1 //ėpG[
#define CMD_NEXT			2 //EnumR}hpA
#define CMD_NON_SUPPORT		3 //T|[g̃R}h
#define CMD_ERR_INVALID_ARG	4 //G[
#define CMD_ERR_CONNECT		5 //T[o[ɃRlNgłȂ
#define CMD_ERR_DISCONNECT	6 //T[o[ؒfꂽ
#define CMD_ERR_TIMEOUT		7 //^CAEg
#define CMD_ERR_BUSY		8 //rW[ԂŌݏłȂ

//R}hMXg[
typedef struct _CMD_STREAM{
	DWORD dwParam; //MR}hAMG[R[h
private:
	DWORD dwSize; //bDataTCY
	BYTE aSmallBuf[20];
public:
	BYTE* bData;
public:

	_CMD_STREAM(void){
		dwSize = 0;
		bData = 0;
	}
	~_CMD_STREAM(void){
		if( bData != NULL && bData != aSmallBuf )
			DELETE_DATA_BUFF(bData, dwSize );
	}

	void SetSize( size_t size ) {
		if( bData != NULL && bData != aSmallBuf )
			DELETE_DATA_BUFF(bData, dwSize );
		if( size > 20 )
			NEW_DATA_BUFF( size );
		else 
			bData = aSmallBuf;
		dwSize = size;
	}
	size_t GetSize() {
		return dwSize;
	}

} CMD_STREAM;


#endif