#pragma once

#include "../../Common/PT1SendCtrlCmdUtil.h"
#include "../../Common/PipeServer.h"
#include "PT1Manager.h"

class CPT1CtrlMain
{
public:
	CPT1CtrlMain(void);
	~CPT1CtrlMain(void);

	void StartMain();
	void StopMain();
	void MainLoop();

protected:
	HANDLE m_hStopEvent;
	HANDLE m_hAllClose;
	CPT1Manager m_cPT1;
	CPipeServer *m_cPipeserver;

protected:
	static int CALLBACK OutsideCmdCallback(void* pParam, CMD_STREAM* pCmdParam, CMD_STREAM* pResParam);

	//CMD_CLOSE_EXE PT1Ctrl.exe̋IR}h ʏ͎gpȂ
	void CmdCloseExe(CMD_STREAM* pCmdParam, CMD_STREAM* pResParam);
	//CMD_OPEN_TUNER OpenTuner
	void CmdOpenTuner(CMD_STREAM* pCmdParam, CMD_STREAM* pResParam);
	//CMD_CLOSE_TUNER CloseTuner
	void CmdCloseTuner(CMD_STREAM* pCmdParam, CMD_STREAM* pResParam);
	//CMD_SET_CH SetChannel
	void CmdSetCh(CMD_STREAM* pCmdParam, CMD_STREAM* pResParam);
	//CMD_GET_SIGNAL GetSignalLevel
	void CmdGetSignal(CMD_STREAM* pCmdParam, CMD_STREAM* pResParam);
	//CMD_OPEN_TUNER2 OpenTuner2
	void CmdOpenTuner2(CMD_STREAM* pCmdParam, CMD_STREAM* pResParam);
};
